Bug 1063040 - Review Request: rubygem-em-socksify - Transparent proxy support for any EventMachine protocol
Review Request: rubygem-em-socksify - Transparent proxy support for any Event...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Ken Dreyer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-02-09 13:01 EST by Nitesh Narayan Lal
Modified: 2016-01-11 02:19 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-11 02:19:11 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
ktdreyer: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Nitesh Narayan Lal 2014-02-09 13:01:17 EST
Spec URL: http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify-0.3.0.spec
SRPM URL: http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-1.fc19.src.rpm
Description: Transparent proxy support for any EventMachine protocol
Fedora Account System Username:
niteshnarayan
Comment 1 Mo Morsi 2014-02-21 08:21:50 EST
Taking this one

Some minor style issues:

- In files list the spec dir, Gemfile, Rakefile, and gemspec should be marked as %doc

- On same not marking files as %doc in the 'doc' subpackage is a bit redundant, though not against guidelines

- Seem to be a bit of extraneous whitespace, consider tidying up

Package does not build in Koji:

http://koji.fedoraproject.org/koji/taskinfo?taskID=6556112

You are trying to use rspec in the %check section w/out listing that as a build requirement. Also I believe your going to need to list the eventmachine dependency as a build requirement so that the test suite fully functions
Comment 2 Nitesh Narayan Lal 2014-02-22 15:02:11 EST
Thanks for the comments I had made the changes as per the comments:
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify-0.3.0.spec
SRPM:http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-2.fc19.src.rpm
Comment 3 Mo Morsi 2014-03-02 08:06:06 EST
Hey Nitesh, looked at the updated package

- As w/ the others please rename spec to 'rubygem-em-socksify.spec'

- You will need to add "BuildRequires: rubygem(eventmachine) >= 1.0.0.beta4" along w/ the other BuildRequires

- .gitignore should be removed or excluded

- "Updated as per the comments" should be changed to something more descriptive

- The %check command should be "rspec -Ilib spec"

- You will need to sed out bundler in spec/helper.rb before running rspec

I made these changes change and ran the build locally and on koji but it failed in both environments:

http://koji.fedoraproject.org/koji/taskinfo?taskID=6587064
http://kojipkgs.fedoraproject.org//work/tasks/7065/6587065/build.log

I suspect this is the culprit

https://github.com/igrigorik/em-socksify/issues/10

Admittedly didn't fully investigate but it looks like the spec is requiring an external proxy to work. This wouldn't work for Fedora (external connections aren't permitted in mock/koji) so we could:

- try to get the issue resolved upstream (add a comment to that issue)

- patch the spec/socksify_spec.rb ourselves to make it compatible

- simply skip the specs (since there are only 2 tests and they both connect to external services)

Feel free to pick a solution and implement or we can discuss more here or on IRC.
Comment 4 Nitesh Narayan Lal 2014-03-09 12:06:21 EDT
Hi, 
I had updated the SPECS, thanks for holding on with this and helping.
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPMS:niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-3.fc20.src.rpm
Comment 5 Mo Morsi 2014-03-13 11:19:23 EDT
Hey Nitesh a couple more things:

- You need to include the full url to the spec and srpm in your comment for the fedora-review tool to pick it up (eg the srpm is missing 'http://'

- Since you are not running the test suite the BuildRequires: (eventmachine) mentioned above can be omitted. Also you can remove the BuildRequires(rspec) from the spec

- There is an extraneous %pushd in the %install section that should be removed

- The %{gem_spec} file should _not_ be excluded (necessary for the gem to work)

- The package should have a copy of the MIT license, see https://fedoraproject.org/wiki/Packaging:LicensingGuidelines?rd=Packaging/LicensingGuidelines#License_Text

Thanks
Comment 6 Mo Morsi 2014-03-13 11:31:57 EDT
One additional thing, the 'rubygems' requirements should be 'Requires: rubygems' and not 'Requires: ruby(rubygems)'

http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems

fedora-review will complain otherwise.
Comment 7 Nitesh Narayan Lal 2014-03-16 08:58:57 EDT
Hi,
I had modified the spec as per the suggestion:
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPM:niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-4.fc20.src.rpm
Comment 8 Nitesh Narayan Lal 2014-03-16 09:00:54 EDT
Hi,
I had modified the spec as per the suggestion:
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPM:http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-4.fc20.src.rpm
Comment 9 Mo Morsi 2014-03-24 10:05:16 EDT
Hey nitesh a couple things:

* Sorry if there was some confusion above but you _need_ "Requires: rubygem(eventmachine) >= 1.0.0.beta4"  but should _not_ have "BuildRequires: rubygem(eventmachine)"

* The "%{gem_instdir}/lib/*" should not be marked as %{doc}, rather just have "%{gem_libdir}" in the files list

Build looks good: http://koji.fedoraproject.org/koji/taskinfo?taskID=6667816
Comment 10 Nitesh Narayan Lal 2014-03-24 12:20:15 EDT
Sorry for the mistakes, I had made the changes. Following are the final files:
SPECS:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPMS:http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-5.fc20.src.rpm
Comment 11 Mo Morsi 2014-03-24 12:39:02 EDT
Package looks good to me, so giving you unofficial ACK.

Assigning to ktdreyer for official review / sponsorship as discussed
Comment 12 Ken Dreyer 2014-03-25 06:47:33 EDT
Hi Nitesh, a couple of additional comments:

- The MIT-LICENSE file in rubygem-em-socksify-0.3.0-5.fc20.src.rpm says "Copyright (c) 2009 - 2014, David Waite and Other Contributors". This is not correct. The main contributor is Ilya Grigorik, and the first commit in Git is from 2011 (not 2009).

We need to be very careful that we do not accidentally indicate that copyright belongs to the wrong person.

(Please see the next item below for a corrected copyright statement in the MIT-LICENSE file.)

- When you see that the MIT license file is missing from upstream, the first place to attempt to solve that is upstream, rather than downstream in Fedora. I've submitted this change here: https://github.com/igrigorik/em-socksify/pull/15

In the future, if you are packaging software that does not have the full license text, please submit this sort of change upstream first.

- For Ruby Gem packages, it's also useful for upstream to have the MIT license metadata in the gemspec. Here's the proposal for that: https://github.com/igrigorik/em-socksify/pull/14 . Again, in the future, please do submit this sort of thing upstream for your packages.

- Please update the URL to use "https" instead of "http". I've proposed this upstream here: https://github.com/igrigorik/em-socksify/pull/16

- Please remove the "Generated from  ... gem2rpm" comment at the top of the file. This line is not necessary for the package and it will become stale over time.

- Please remove the trailing spaces at the end of the rubygems-devel line (line 17) and popd line (line 56):

  17  BuildRequires: rubygems-devel 

  56  #popd	

- Please remove the following line:

  BuildRequires: ruby 

This is only necessary on the arch-specific (binary) gems. Since your em-socksify package is noarch, you only need ruby(release).

- Please adjust the following line:

  %{gem_instdir}/spec/* 

to be simply

  %{gem_instdir}/spec
 
This will tell RPM to capture the spec directory as well as the contents within. Please remove the trailing whitespace from this line as well.

- Please add a second percent sign (%) to the macros that are commented in %check. So "%check" becomes "%%check", and "./%{gem_instdir}" becomes "./%%{gem_instdir}". The reason for doing this is that rpmlint will complain about unescaped macros in the comments. Even if a macro is commented, RPM will still expand it. Sometimes its innocuous and it's not a problem, but other times it can cause unexpected behavior, so it's always best to escape all the rpmlint warnings about this to be on the safe side.
Comment 13 Nitesh Narayan Lal 2014-03-25 12:26:38 EDT
Hi,
Thanks for your comments, here are the changed files:
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPM:http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-6.fc20.src.rpm
Comment 14 Ken Dreyer 2014-03-28 06:26:42 EDT
Hi Nitesh, the copyright statement in the rubygem-em-socksify-0.3.0-6.fc20.src.rpm's MIT-LICENSE file still contains the factual errors indicated in Comment 12. Please see https://github.com/igrigorik/em-socksify/blob/master/MIT-LICENSE .

It's really important that you understand this and the reasons why this is bad. We need to avoid the appearance that Fedora is ignoring or changing authors' rights under copyright law.
Comment 15 Mo Morsi 2014-03-28 10:05:58 EDT
(In reply to Ken Dreyer from comment #14)
> It's really important that you understand this and the reasons why this is
> bad. We need to avoid the appearance that Fedora is ignoring or changing
> authors' rights under copyright law.

+1, Nitesh also please make sure to incorporate _all_ feedback into package updates. Even if this means taking an extra day or two to double check you got everything. It saves the reviewer from wasting time. Thank you.
Comment 16 Nitesh Narayan Lal 2014-03-28 11:52:30 EDT
Hi,
I am really sorry for the missed out thing. I will make sure that I don't make these kind of mistakes in the future.
SPEC:http://niteshnarayan.fedorapeople.org/SPECS/rubygem-em-socksify.spec
SRPM:http://niteshnarayan.fedorapeople.org/SRPMS/rubygem-em-socksify-0.3.0-7.fc20.src.rpm
Comment 17 Ken Dreyer 2014-05-15 21:42:07 EDT
Hi Nitesh, please accept my apologies for taking so long to get back on this review.

The package looks good.

With the latest Ruby guidelines for Fedora 21, you will not need to explicitly declare Requires or Provides for your gem. Please use dist tags to wrap the Requires and Provides, like so:

  %if 0%{?fc19} || 0%{?fc20}
  Requires: ruby(release)
  Requires: rubygems
  Requires: rubygem(eventmachine) >= 1.0.0.beta.4
  %endif

and

  %if 0%{?fc19} || 0%{?fc20} 
  Provides: rubygem(%{gem_name}) = %{version}
  %endif

When Fedora 19 goes end-of-life, you can remove the "0%{?fc19}" part, and when Fedora 20 goes end-of-life, you can remove the whole Requires and Provides sections entirely.

See https://fedoraproject.org/wiki/Packaging:DistTag for more information about dist tags.

As a separate issue, please mark the %{gem_instdir}/README.md file as "%doc", since it is documentation, not code. (that one's confusing since it's already in a -doc subpackage...)

Please make these changes and I'll approve the package and sponsor you (with the caveat that mmorsi will be your main mentor and responsible for your actions in Fedora going forward).

Full fedora-review output follows.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
     See above note about wrappingn Requires and Provides in a dist tag.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).
[x]: Package contains Requires: ruby(release).

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Avoid bundling fonts in non-fonts packages.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
     This is ok - packager has provided explanation in comments.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[!]: Test suite of the library should be run.
     This is ok - packager has provided explanation in comments.
[x]: Specfile should use macros from rubygem-devel package.
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-em-socksify-0.3.0-7.fc21.noarch.rpm
          rubygem-em-socksify-doc-0.3.0-7.fc21.noarch.rpm
          rubygem-em-socksify-0.3.0-7.fc21.src.rpm
rubygem-em-socksify.noarch: E: useless-provides rubygem(em-socksify)
3 packages and 0 specfiles checked; 1 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-em-socksify-doc rubygem-em-socksify
rubygem-em-socksify.noarch: E: useless-provides rubygem(em-socksify)
2 packages and 0 specfiles checked; 1 errors, 0 warnings.

Requires
--------
rubygem-em-socksify-doc (rpmlib, GLIBC filtered):
    rubygem-em-socksify

rubygem-em-socksify (rpmlib, GLIBC filtered):
    ruby(release)
    ruby(rubygems)
    rubygem(eventmachine)
    rubygems


Provides
--------
rubygem-em-socksify-doc:
    rubygem-em-socksify-doc

rubygem-em-socksify:
    rubygem(em-socksify)
    rubygem-em-socksify



Source checksums
----------------
https://rubygems.org/gems/em-socksify-0.3.0.gem :
  CHECKSUM(SHA256) this package     : 2a9feb13e65efc89434008e99dda9d80e11f9aa1a294dda60a2c400134896b89
  CHECKSUM(SHA256) upstream package : 2a9feb13e65efc89434008e99dda9d80e11f9aa1a294dda60a2c400134896b89


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1063040 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Ruby, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 18 Mo Morsi 2014-05-28 08:22:30 EDT
(In reply to Ken Dreyer from comment #17)

> With the latest Ruby guidelines for Fedora 21, you will not need to
> explicitly declare Requires or Provides for your gem. Please use dist tags
> to wrap the Requires and Provides, like so:
> 
>   %if 0%{?fc19} || 0%{?fc20}
>   Requires: ruby(release)
>   Requires: rubygems
>   Requires: rubygem(eventmachine) >= 1.0.0.beta.4
>   %endif
> 

Am a little confused as to whether ruby(release) should or should not be included, brought up the issue on the ruby sig mailing list:

https://lists.fedoraproject.org/pipermail/ruby-sig/2014-May/001588.html


> As a separate issue, please mark the %{gem_instdir}/README.md file as
> "%doc", since it is documentation, not code. (that one's confusing since
> it's already in a -doc subpackage...)

It was my understanding that files in the 'doc' subpackage didn't need to be marked as %doc (since that is the whole intent of the subpackage). I could be wrong on this, and know that it is ok to mark doc subpkg files as %doc, so am fine either way.



> 
> Please make these changes and I'll approve the package and sponsor you (with
> the caveat that mmorsi will be your main mentor and responsible for your
> actions in Fedora going forward).
> 

Thanks Ken, yes I am fine w/ this. Nitesh I just ask that if you are unsure about something, just ask me before committing / building. Most likely after a while this will be unnecessary but at the beginning there are many gotcha's/edge cases. Thanks again for the new package.
Comment 20 Ken Dreyer 2014-07-08 14:49:53 EDT
The latest changes look good. I've sponsored you into the packagers group. (Please remove FE-NEEDSPONSOR from your other package review requests).
Comment 21 Nitesh Narayan Lal 2014-07-14 10:13:39 EDT
New Package SCM Request
=======================
Package Name:rubygem-em-socksify
Short Description: Ruby gem for transparent proxy support for any EventMachine protocol 
Upstream URL: https://github.com/igrigorik/em-socksify
Owners: niteshnarayan, mmorsi
Branches: f19 f20 f21 el6 epel7
InitialCC:
Comment 22 Jon Ciesla 2014-07-14 14:04:08 EDT
Git done (by process-git-requests).
Comment 23 Fedora Update System 2014-07-15 14:01:53 EDT
rubygem-em-socksify-0.3.0-8.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/rubygem-em-socksify-0.3.0-8.fc20
Comment 24 Fedora Update System 2014-07-17 00:32:14 EDT
rubygem-em-socksify-0.3.0-8.fc20 has been pushed to the Fedora 20 testing repository.

Note You need to log in before you can comment on or make changes to this bug.